
FileLoader = Core.class(Timer)

function FileLoader:init(delay, repeatCount) -- STARTUP
  self:addEventListener(Event.TIMER, self.onTimer, self)
  self.callBack = nil
  self.file = nil
  self.output = {}
  self.questions = {}
  self.began = 0
  self.elapsed = 0
end

function FileLoader:dispose() -- SHUTDOWN
  self:stop()
  self:removeEventListener(Event.TIMER, self.onTimer, self)
  self.callBack = nil
  if self.file then self.file.close() end
  self.file = nil
  self.output = nil
  self.began = nil
  self.elapsed = nil
end

function FileLoader:beginLoad(fileName, callBack) -- BEGIN LOADING A NEW FILE
  self:stop()
  self:reset()
  if self.file then self.file.close() end
  self.output = {}
  self.file = io.open(fileName, "r")
  self.callBack = callBack or nil
  self.began = os.timer()
  self:start()
end

function FileLoader:onTimer() -- PROCESS NEXT LINE IN FILE
  local input = self.file:read( "*l" ) -- READ ONE LINE FROM FILE
  if input then
    table.insert(self.output, input) -- INSERT LINE
  else
    self:stop()
    self.file:close() -- DISPOSE OF FILE
    self.file = nil
    self.elapsed = math.floor((os.timer() - self.began) * 1000)
    if self.callBack then
      self.callBack(self.output) -- CALL USER FUNCTION HERE
      self.callBack = nil
    end
  end
end

--local questions = self.questions

--local data = self.output

--local question = {}
--local answers = {}

--for i = 1, #data do
--  local line = data[i]

--end



