--require("mobdebug").start()

local FileLoader = FileLoader.new(10, 0) -- NEW FILE LOADER THAT READS ONE LINE EACH n MS

local questions = {}

local function generateQuestions(data) -- GENERATE QUESTIONS FROM DATA
  local ssub, insert = string.sub, table.insert
  
  local output = {}
  local question = {question = "", answers = {}} -- BLANK QUESTION
  for i = 1, #data do
    local line = data[i]
    if string.sub(line, 1, 1) == "*" then -- LINES BEGINNING WITH * DENOTES A QUESTION
      if i > 1 then -- SKIP 1ST INSERT BECAUSE IT WILL ALWAYS BE EMPTY
        table.insert(output, question) -- ADD NEW QUESTION
      end
      question = {question = string.sub(line ,2), answers = {}} -- NEW QUESTION WITH "*" STRIPPED OFF
    else
      table.insert(question.answers, line) -- ALL OTHER LINES ARE ANSWERS (FIRST ONE BEING THE REAL ANSWER)
    end
  end
  table.insert(output, question) -- ADD LAST QUESTION
  return output
end

local function fileLoaded(data)
  print( #data.." lines loaded in "..FileLoader.elapsed.."ms")
  
  questions = generateQuestions(data)
end

FileLoader:beginLoad("data/somedata.txt", fileLoaded)
